summaryrefslogtreecommitdiff
path: root/src/scripts/lookups-Makefile
diff options
context:
space:
mode:
Diffstat (limited to 'src/scripts/lookups-Makefile')
-rwxr-xr-xsrc/scripts/lookups-Makefile85
1 files changed, 85 insertions, 0 deletions
diff --git a/src/scripts/lookups-Makefile b/src/scripts/lookups-Makefile
new file mode 100755
index 000000000..7069cfb69
--- /dev/null
+++ b/src/scripts/lookups-Makefile
@@ -0,0 +1,85 @@
+#! /bin/sh
+
+# We turn the configure-built build-$foo/lookups/Makefile.predynamic into Makefile
+
+input=lookups/Makefile.predynamic
+target=lookups/Makefile
+defs_source=Makefile
+tag_marker='MAGIC-TAG-MODS-OBJ-RULES-GO-HERE'
+
+tab=' '
+if grep -q "^LOOKUP.*=[ $tab]*2" "$defs_source"
+then
+ # we have work to do
+else
+ echo "No dynamic module loading support"
+ cp "$input" "$target"
+ exit 0
+fi
+
+if grep -q "^CFLAGS_DYNAMIC[ $tab]*=" "$defs_source"
+then
+ # we have a definition, we're good to go
+else
+ echo >&2 "Missing CFLAGS_DYNAMIC inhibits building dynamic module lookup"
+ exit 1
+fi
+
+tmp="$target.t"
+
+want_dynamic() {
+ local dyn_name="$1"
+ grep -q "^LOOKUP_${dyn_name}[ $tab]*=[ $tab]*2" "$defs_source"
+}
+
+want_at_all() {
+ local want_name="$1"
+ grep -q "^LOOKUP_${want_name}[ $tab]*=[ $tab]*." "$defs_source"
+}
+
+emit_module_rule() {
+ local lookup_name="$1"
+ local mod_name
+ if [ "${lookup_name%:*}" = "$lookup_name" ]
+ then
+ mod_name=$(echo $lookup_name | tr A-Z a-z)
+ else
+ mod_name="${lookup_name#*:}"
+ lookup_name="${lookup_name%:*}"
+ fi
+
+ if want_dynamic "$lookup_name"
+ then
+ echo "MODS += ${mod_name}.so"
+ echo "LOOKUP_${mod_name}_INCLUDE = \$(LOOKUP_${lookup_name}_INCLUDE)"
+ echo "LOOKUP_${mod_name}_LIBS = \$(LOOKUP_${lookup_name}_LIBS)"
+ elif want_at_all "$lookup_name"
+ then
+ echo "OBJ += ${mod_name}.o"
+ fi
+}
+
+exec 5>&1
+exec > "$tmp"
+
+sed -n "1,/$tag_marker/p" < "$input"
+
+for name_mod in \
+ CDB DBM:dbmdb DNSDB DSEARCH IBASE LSEARCH MYSQL NIS NISPLUS ORACLE \
+ PASSWD PGSQL SQLITE TESTDB WHOSON
+do
+ emit_module_rule $name_mod
+done
+
+if want_at_all LDAP
+then
+ echo "OBJ += ldap.o"
+fi
+
+sed -n "/$tag_marker/,\$p" < "$input"
+
+exec >&5
+mv "$tmp" "$target"
+
+
+# vim: set ft=sh sw=2 :